diff --git a/python/automake.mk b/python/automake.mk
index 9ce81a0d2..7a7c39343 100644
--- a/python/automake.mk
+++ b/python/automake.mk
@@ -87,7 +87,9 @@ EXTRA_DIST += \
 # PyPI support.
 EXTRA_DIST += \
 	python/ovs/compat/sortedcontainers/LICENSE \
+	python/ovs/flowviz/ovs-flowviz.conf \
 	python/README.rst \
+	python/setup.py \
 	python/test_requirements.txt
 
 # C extension support.
@@ -109,6 +111,8 @@ FLAKE8_PYFILES += \
 	python/setup.py.template
 
 nobase_pkgdata_DATA = $(ovs_pyfiles) $(ovstest_pyfiles) $(ovs_flowviz)
+nobase_pkgdata_DATA += python/ovs/flowviz/ovs-flowviz.conf
+
 ovs-install-data-local:
 	$(MKDIR_P) python/ovs
 	sed \
diff --git a/python/ovs/flowviz/ovs-flowviz.conf b/python/ovs/flowviz/ovs-flowviz.conf
new file mode 100644
index 000000000..3acd0a29e
--- /dev/null
+++ b/python/ovs/flowviz/ovs-flowviz.conf
@@ -0,0 +1,94 @@
+# Create any number of styles.{style_name} sections with a defined style.
+#
+# Syntax:
+#
+#  [FORMAT].[PORTION].[SELECTOR].[ELEMENT] = [VALUE]
+#
+#  * FORMAT: console
+#  * PORTION: The portion of the flow that the style applies to
+#     - key: Selects how to print the key of a KeyValue pair
+#     - key: Selects how to print the value of a KeyValue pair
+#     - flag: Selects how to print the a flag
+#     - delim: Selects how to print the delimiters around key and values
+#
+#  * SELECTOR:
+#    - highlighted: to apply when the key is highlighted
+#    - type.{TYPE}: to apply when the value matches a type
+#       (special types such as IPAddress or EthMask can be used)
+#       (only aplicable to 'value')
+#    - {key_name}: to apply when the key matches the key_name
+#
+# Console Styles
+# ==============
+#   * ELEMENT:
+#     - color: defines the color in hex or a color rich starndard ones [1]
+#     - underline: if set to "true", the selected portion will be underlined
+#
+#[1] https://rich.readthedocs.io/en/stable/appendix/colors.html#standard-colors
+
+[styles.dark]
+
+# defaults for key-values
+console.key.color = #5D86BA
+console.value.color= #B0C4DE
+console.delim.color= #B0C4DE
+console.default.color= #FFFFFF
+
+# defaults for special types
+console.value.type.IPAddress.color = #008700
+console.value.type.IPMask.color = #008700
+console.value.type.EthMask.color = #008700
+
+# dim some long arguments
+console.value.ct.color = grey66
+console.value.ufid.color = grey66
+console.value.clone.color = grey66
+console.value.controller.color = grey66
+
+# highlight flags
+console.flag.color = #875fff
+
+# show drop and recirculations
+console.key.drop.color = red
+console.key.resubmit.color = #00d700
+console.key.output.color = #00d700
+console.value.output.color = #00d700
+
+# highlights
+console.key.highlighted.color = red
+console.key.highlighted.underline = true
+console.value.highlighted.underline = true
+console.delim.highlighted.underline = true
+
+
+[styles.light]
+# If a color is omitted, the default terminal color will be used
+# highlight keys
+console.key.color = blue
+
+# special types
+console.value.type.IPAddress.color = #008700
+console.value.type.IPMask.color = #008700
+console.value.type.EthMask.color = #008700
+
+# dim long arguments
+console.value.ct.color = bright_black
+console.value.ufid.color = #870000
+console.value.clone.color = bright_black
+console.value.controller.color = bright_black
+
+# highlight flags
+console.flag.color = #00005F
+
+# show drop and recirculations
+console.key.drop.color = red
+console.key.resubmit.color = #00d700
+console.key.output.color = #005f00
+console.value.output.color = #00d700
+
+# highlights
+console.key.highlighted.color = #f20905
+console.value.highlighted.color = #f20905
+console.key.highlighted.underline = true
+console.value.highlighted.underline = true
+console.delim.highlighted.underline = true
diff --git a/python/setup.py.template b/python/setup.py.template
index 7c940f39a..5d48980c5 100644
--- a/python/setup.py.template
+++ b/python/setup.py.template
@@ -109,6 +109,7 @@ setup_args = dict(
                         [*flow_extras_require, 'click', 'rich'],
                     },
     scripts=["ovs/flowviz/ovs-flowviz"],
+    data_files=["ovs/flowviz/ovs-flowviz.conf"],
     include_package_data=True,
 )
 